<?php
/*
* $Id: catKissIt.php
* $Loc: /includes/hooks/admin/siteWide/
*
* Name: KiissitImageAdminSupport
* Version: 4.6.0
* Release Date: 06/01/2024
* Author: Rainer Schmied
* 	 phoenixcartaddonsaddons.com / raiwa@phoenixcartaddons.com
*
* License: Released under Commercial License
*
* Comments:  Author: [Rainer Schmied @raiwa]
*  Author URI: [www.phoenixcartaddons.com]
*  License: Commercial License Rainer Schmied
*  License URI: https://www.phoenixcartaddons.com/license.php
* 
*  Copyright (c) 2024 Rainer Schmied
*  
*  Redistribution and use in source and binary forms, with or without
*  modification, are not permitted without specific prior written permission
*  from Rainer Schmied
* 
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
*  SOFTWARE.
*  
* 
*/

class hook_admin_siteWide_catKissIt {

  public $version = '4.5.2';

  function listen_injectSiteEnd() {
    global $action;

    if ( Request::get_page() == 'catalog.php' ) {
      $output = null;

      if ( !isset($action) || ($action != 'edit_category'  && $action != 'new_product'  && $action != 'new_product_preview') ) {

        $categories = $GLOBALS['categories_query']->data_seek(0);

        $header_title_thumb = HEADER_TITLE_IMAGE;

        $output .= <<<EOD
<script>
$(function() {
$('table:eq(0) thead tr th:nth-child(1)').before('<th>{$header_title_thumb}</th>');
EOD;

        $categories_root = !empty($_GET['cPath']) ? $_GET['cPath'] . '_' : '';
        while ( $categories = $GLOBALS['categories_query']->fetch_assoc() ) {

          $c_id_selector = $categories_root .  $categories['categories_id'];
          if ( !empty($categories['categories_image']) ) {
            $categories_thumb = $GLOBALS['Admin']->catalog_image('images/' . $categories['categories_image'], ['alt' => $categories['categories_name'], 'width' => HEADING_IMAGE_WIDTH, 'height' => HEADING_IMAGE_HEIGHT]);
          } else {
            $categories_thumb = '';
          }
          $output .=  PHP_EOL . <<<EOD
$('table tbody td:has([href$="cPath={$c_id_selector}"])').parent().find('th').before('<th>{$categories_thumb}</th>');
EOD;
        }

        $products = $GLOBALS['products_query']->data_seek(0);

        while ( $products = $GLOBALS['products_query']->fetch_assoc() )  {

          $products_id = $products['products_id'];
          if ( !empty($products['products_image']) ) {
            $products_thumb = $GLOBALS['Admin']->catalog_image('images/' . $products['products_image'], ['alt' => $products['products_name'], 'width' => '50', 'height' => '50']);
          } else {
            $products_thumb = '';
          }

          $output .=  PHP_EOL . <<<EOD
$('table tbody td:has([href*="pID={$products_id}&"])').parent().find('th').not('.pname').addClass('pname').before('<th class="pname">{$products_thumb}</th>');
EOD;
        }

        $output .= <<<EOD
});
</script>
EOD;

        return $output;

      }

    }

  }

}
