<?php
/*
* $Id: kissImageInstall.php
* $Loc: /includes/hooks/admin/siteWide/
*
* Name: KissitImage
* Version: 4.7.1
* Release Date: 11/29/2024
* Author: Rainer Schmied
* 	 phoenixcartaddonsaddons.com / raiwa@phoenixcartaddons.com
*
* License: Released under Commercial License
*
* Comments:  Author: [Rainer Schmied @raiwa]
*  Author URI: [www.phoenixcartaddons.com]
*  License: Commercial License Rainer Schmied
*  License URI: https://www.phoenixcartaddons.com/license.php
* 
*  Copyright (c) 2024 Rainer Schmied
*  
* Based on:
* S. Mohammed Alsharaf, http://www.zfsnippets.com/snippets/view/id/44.
* Copyright 2008-2009 FWR Media ( Robert Fisher )
* 
* Author Robert Fisher, FWR Media, http://www.fwrmedia.co.uk
*  Redistribution and use in source and binary forms, with or without
*  modification, are not permitted without specific prior written permission
*  from Rainer Schmied
* 
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
*  SOFTWARE.
*  
* 
*/

class hook_admin_siteWide_kissImageInstall {

  public $version = '4.7.0';

  function listen_injectSiteStart() {
    global $db;

    if ( !defined('KISSIT_IMAGE_MODULE') || KISSIT_IMAGE_MODULE != '4.7.0 Pro' || !defined('SMALL_IMAGE_WIDTH') ) {

      $db->query("UPDATE hooks
                    SET hooks_method = 'image'
                    WHERE hooks_site = 'shop'
                    AND hooks_group = 'system'
                    AND hooks_action = 'startApplication'
                    AND hooks_code = '_06_image'
                    AND hooks_class = 'function_surface';
                 ");

      if ( !defined('KISSIT_IMAGE_MODULE') ) {
        $db->query("INSERT INTO configuration (configuration_title,configuration_key,configuration_value,configuration_description,configuration_group_id,sort_order,date_added, use_function, set_function) VALUES
                      ('KissIT: Version', 'KISSIT_IMAGE_MODULE', '" . $this->version . "', 'KISS Image Thumbnailer - Creates image thumbnails where the image size requested differs from the actual image size', '6', '0', NOW(), null, null);
                     ");
      } else{
        $db->query("UPDATE configuration
                      SET configuration_value ='" . $this->version . "'  WHERE configuration_key= 'KISSIT_IMAGE_MODULE';");
      }
      if ( !defined('KISSIT_MAIN_PRODUCT_IMAGE_WIDTH') ) {
        $db->query("INSERT INTO configuration (configuration_title,configuration_key,configuration_value,configuration_description,configuration_group_id,sort_order,date_added, use_function, set_function) VALUES
                      ('Kissit Main Product Image Width', 'KISSIT_MAIN_PRODUCT_IMAGE_WIDTH', '500', 'Main product image width used in Product Info Gallery module.', '4', '18', NOW(), null, null);
                     ");
      } else {
        $db->query("UPDATE configuration SET `configuration_title`='Main Product Image Width', `configuration_value`='500', `configuration_description`='Main product image width used in Product Info Gallery module.', `sort_order`='18'  WHERE configuration_key= 'KISSIT_MAIN_PRODUCT_IMAGE_WIDTH';");
      }
      if ( !defined('KISSIT_MAIN_PRODUCT_IMAGE_HEIGHT') ) {
        $db->query("INSERT INTO configuration (configuration_title,configuration_key,configuration_value,configuration_description,configuration_group_id,sort_order,date_added, use_function, set_function) VALUES
                      ('Kissit Main Product Image Height', 'KISSIT_MAIN_PRODUCT_IMAGE_HEIGHT', '500', 'Main product image height used in Product Info Gallery module.', '4', '19', NOW(), null, null);
                     ");
      } else {
        $db->query("UPDATE configuration SET `configuration_title`='Main Product Image Height', `configuration_value`='500', `configuration_description`='Main product image height used in Product Info Gallery module.', `sort_order`='19'  WHERE configuration_key= 'KISSIT_MAIN_PRODUCT_IMAGE_HEIGHT';");
      }
      if ( !defined('KISSIT_GALLERY_PRODUCT_IMAGE_WIDTH') ) {
        $db->query("INSERT INTO configuration (configuration_title,configuration_key,configuration_value,configuration_description,configuration_group_id,sort_order,date_added, use_function, set_function) VALUES
                      ('KissIT Product Gallery Image Width', 'KISSIT_GALLERY_PRODUCT_IMAGE_WIDTH', '150', 'KissIT Product Gallery Image Width used in Product Info Gallery module.', '4', '20', NOW(), null, null);
                     ");
      } else {
        $db->query("UPDATE configuration SET `configuration_title`='KissIT Product Gallery Image Width', `configuration_value`='150', `configuration_description`='KissIT Product Gallery Image Width used in Product Info Gallery module', `sort_order`='20'  WHERE configuration_key= 'KISSIT_GALLERY_PRODUCT_IMAGE_WIDTH';");
      }
      if ( !defined('KISSIT_GALLERY_PRODUCT_IMAGE_HEIGHT') ) {
        $db->query("INSERT INTO configuration (configuration_title,configuration_key,configuration_value,configuration_description,configuration_group_id,sort_order,date_added, use_function, set_function) VALUES
                      ('KissIT Product Gallery Image Height', 'KISSIT_GALLERY_PRODUCT_IMAGE_HEIGHT', '150', 'KissIT Product Gallery Image Height used in Product Info Gallery module.', '4', '21', NOW(), null, null);
                     ");
      } else {
        $db->query("UPDATE configuration SET `configuration_title`='KissIT Product Gallery Image Height', `configuration_value`='150', `configuration_description`='KissIT Product Gallery Image Height used in Product Info Gallery module', `sort_order`='21'  WHERE configuration_key= 'KISSIT_GALLERY_PRODUCT_IMAGE_HEIGHT';");
      }
      if ( !defined('KISSIT_MIN_IMAGE_SIZE') ) {
        $db->query("INSERT INTO configuration (configuration_title,configuration_key,configuration_value,configuration_description,configuration_group_id,sort_order,date_added, use_function, set_function) VALUES
                      ('KissIT min image size', 'KISSIT_MIN_IMAGE_SIZE', '25', 'Minimum image size in px to trigger Thumbnail creation.<br>Recommended range 10-50.<br>Default: 25.', '4', '22', NOW(), null, null);
                     ");
      }
      if ( !defined('KISS_DISABLE_UPSIZE') ) {
        $db->query("INSERT INTO configuration (configuration_title,configuration_key,configuration_value,configuration_description,configuration_group_id,sort_order,date_added, use_function, set_function) VALUES
                      ('KissIT Disable Image Upsize', 'KISS_DISABLE_UPSIZE', 'true', 'Keep original image size if the original image is smaller than the requested thumbnail size.', '4', '23', NOW(), null, '" . $db->escape("Config::select_one(['True', 'False'], ") . "');
                     ");
      } else {
        $db->query("UPDATE configuration SET `set_function` = '" . $db->escape("Config::select_one(['true', 'false'], ") . "' WHERE configuration_key = 'KISS_DISABLE_UPSIZE';");
      }
      if ( !defined('KISSIT_MAIN_PRODUCT_WATERMARK_SIZE') ) {
        $db->query("INSERT INTO configuration (configuration_title,configuration_key,configuration_value,configuration_description,configuration_group_id,sort_order,date_added, use_function, set_function) VALUES
                      ('KissIT Product Watermark Size', 'KISSIT_MAIN_PRODUCT_WATERMARK_SIZE', '0.6', 'KissIT Product Main Watermark size relativ to the image size (1.0=100%, 0.5 = 50%, 0=no watermark).<br>Change requires Thumbs cache reset.', '4', '24', NOW(), null, null);
                     ");
      }
      if ( !defined('KISSIT_MAIN_PRODUCT_WATERMARK_IMAGE') ) {
        $db->query("INSERT INTO configuration (configuration_title,configuration_key,configuration_value,configuration_description,configuration_group_id,sort_order,date_added, use_function, set_function) VALUES
                      ('KissIT Watermark File Name', 'KISSIT_MAIN_PRODUCT_WATERMARK_IMAGE', 'watermark.png', 'Name of Watermark image file placed in the folder /images. Remember to use a png file with transparent background.<br>Change requires Thumbs cache reset.', '4', '25', NOW(), null, null);
                     ");
      }
      if ( !defined('KISSIT_MAIN_PRODUCT_WATERMARK_PLACEMENT') ) {
        $db->query("INSERT INTO configuration (configuration_title,configuration_key,configuration_value,configuration_description,configuration_group_id,sort_order,date_added, use_function, set_function) VALUES
                      ('KissIT Watermark position in image', 'KISSIT_MAIN_PRODUCT_WATERMARK_PLACEMENT', 'center', 'Position of the watermark in the image reletiv within the image.<br>Change requires Thumbs cache reset.', '4', '26', NOW(), null, '" . $db->escape("Config::select_one(['top-right', 'top-left', 'center','bottom-right', 'bottom-left'], ") . "');
                     ");
      } else {
        $db->query("UPDATE configuration SET `set_function` = '" . $db->escape("Config::select_one(['top-right', 'top-left', 'center','bottom-right', 'bottom-left'], ") . "' WHERE configuration_key = 'KISSIT_MAIN_PRODUCT_WATERMARK_PLACEMENT';");
      }
      if ( !defined('KISSIT_MAIN_PRODUCT_WATERMARK_MIN_IMAGE_WIDTH') ) {
        $db->query("INSERT INTO configuration (configuration_title,configuration_key,configuration_value,configuration_description,configuration_group_id,sort_order,date_added, use_function, set_function) VALUES
                      ('KissIT min image width to apply Watermark', 'KISSIT_MAIN_PRODUCT_WATERMARK_MIN_IMAGE_WIDTH', '60', 'The minimum width of thumbnail images to apply the watermark.<br>Change requires Thumbs cache reset.', '4', '27', NOW(), null, null);
                     ");
      }
      if ( !defined('KISSIT_MAIN_PRODUCT_WATERMARK_MIN_IMAGE_HEIGHT') ) {
        $db->query("INSERT INTO configuration (configuration_title,configuration_key,configuration_value,configuration_description,configuration_group_id,sort_order,date_added, use_function, set_function) VALUES
                      ('KissIT min image height to apply Watermark', 'KISSIT_MAIN_PRODUCT_WATERMARK_MIN_IMAGE_HEIGHT', '60', 'The minimum height of thumbnail images to apply the watermark.<br>Change requires Thumbs cache reset.', '4', '28', NOW(), null, null);
                     ");
      }
      if ( !defined('KISSIT_JPEG_QUALITY') ) {
        $db->query("INSERT INTO configuration (configuration_title,configuration_key,configuration_value,configuration_description,configuration_group_id,sort_order,date_added, use_function, set_function) VALUES
                      ('KissIT JPEG/WEBP Quality', 'KISSIT_JPEG_QUALITY', '75', 'Jpeg and Webp quality setting, range 0-100.<br>75 corresponds to Photoshop setting 9.<br>Change requires Thumbs cache reset.', '4', '30', NOW(), null, null);
                     ");
      }
      if ( !defined('KISSIT_APPLY_BACKGROUND') ) {
        $db->query("INSERT INTO configuration (configuration_title,configuration_key,configuration_value,configuration_description,configuration_group_id,sort_order,date_added, use_function, set_function) VALUES
                      ('KissIT apply Background', 'KISSIT_APPLY_BACKGROUND', 'true', 'Apply additional Background to fit required proportion and size.<br>Applies to JPEG. PNG/GIF will use transparent Background.<br>Change requires Thumbs cache reset.', '4', '31', NOW(), null, '" . $db->escape("Config::select_one(['true', 'false'], ") . "');
                     ");
      } else {
        $db->query("UPDATE configuration SET `set_function` = '" . $db->escape("Config::select_one(['true', 'false'], ") . "' WHERE configuration_key = 'KISSIT_APPLY_BACKGROUND';");
      }
      if ( !defined('KISSIT_BACKGROUND_COLOR') ) {
        $db->query("INSERT INTO configuration (configuration_title,configuration_key,configuration_value,configuration_description,configuration_group_id,sort_order,date_added, use_function, set_function) VALUES
                      ('KissIT Background Color', 'KISSIT_BACKGROUND_COLOR', '255,255,255', 'RGB color of the added Background.<br><br>Comma separated values:<br>Default: white => 255,255,255.<br>Change requires Thumbs cache reset.', '4', '32', NOW(), null, null);
                     ");
      }
      if ( !defined('KISSIT_SHARPEN_THUMBNAIL') ) {
        $db->query("INSERT INTO configuration (configuration_title,configuration_key,configuration_value,configuration_description,configuration_group_id,sort_order,date_added, use_function, set_function) VALUES
                      ('KissIT sharpen Thumbnail', 'KISSIT_SHARPEN_THUMBNAIL', 'medium', 'Apply Sharpening Filter to Thumbnails.<br>Default: medium.<br>Change requires Thumbs cache reset.', '4', '33', NOW(), null, '" . $db->escape("Config::select_one(['none', 'soft', 'medium','strong'], ") . "');
                     ");
      } else {
        $db->query("UPDATE configuration SET `set_function` = '" . $db->escape("Config::select_one(['none', 'soft', 'medium','strong'], ") . "' WHERE configuration_key = 'KISSIT_SHARPEN_THUMBNAIL';");
      }
      if ( !defined('KISSIT_THUMBS_MAIN_DIR') ) {
        $db->query("INSERT INTO configuration (configuration_title,configuration_key,configuration_value,configuration_description,configuration_group_id,sort_order,date_added, use_function, set_function) VALUES
                      ('KissIT thumb directory', 'KISSIT_THUMBS_MAIN_DIR', 'thumbs/', 'The name of the thumbs directory inside \"images\".<br>default: \'thumbs\'<br>Change requires Thumbs cache reset.', '4', '34', NOW(), null, null);
                     ");
      }
      if ( !defined('KISSIT_RESET_IMAGE_THUMBS') ) {
        $db->query("INSERT INTO configuration (configuration_title,configuration_key,configuration_value,configuration_description,configuration_group_id,sort_order,date_added, use_function, set_function) VALUES
                      ('KissIT Reset thumbs', 'KISSIT_RESET_IMAGE_THUMBS', 'false', 'Reset thumbs cache.', '4', '35', NOW(), 'tep_cfg_reset_thumbs_cache', '" . $db->escape("Config::select_one(['reset', 'false'], ") . "');
                     ");
      } else {
        $db->query("UPDATE configuration SET `set_function` = '" . $db->escape("Config::select_one(['reset', 'false'], ") . "' WHERE configuration_key = 'KISSIT_RESET_IMAGE_THUMBS';");
      }
      if ( !defined('KISSIT_PRO') ) {
        $db->query("INSERT INTO configuration (configuration_title,configuration_key,configuration_value,configuration_description,configuration_group_id,sort_order,date_added, use_function, set_function) VALUES
                      ('<a target=\"_blank\" href=\"http://www.oscaddons.com/en/commercial-add-ons/kissit-image-thumbnailer-pro-p-63.html\"><strong>Get KissIT Pro</strong></a>', 'KISSIT_PRO', '', 'KissIT Pro introduces support for the html tag \"srcset:\" It allows to indicate the browser that different versions of an image are available to fit the different needs of high resolution/retina devices and smaller devices.', '4', '36', NOW(), null, null);
                     ");
      }
      if ( !defined('SMALL_IMAGE_WIDTH') ) {
        $db->query("INSERT INTO configuration (configuration_title,configuration_key,configuration_value,configuration_description,configuration_group_id,sort_order,date_added, use_function, set_function) VALUES
                      ('Small Image Width', 'SMALL_IMAGE_WIDTH', '250', 'The pixel width of small images', '4', '1', NOW(), null, null);
                     ");
      } else{
        $db->query("UPDATE `configuration` SET `configuration_value`='250'  WHERE configuration_key= 'SMALL_IMAGE_WIDTH';");
      }
      if ( !defined('SMALL_IMAGE_HEIGHT') ) {
        $db->query("INSERT INTO configuration (configuration_title,configuration_key,configuration_value,configuration_description,configuration_group_id,sort_order,date_added, use_function, set_function) VALUES
                      ('Small Image Height', 'SMALL_IMAGE_HEIGHT', '250', 'The pixel height of small images', '4', '2', NOW(), null, null);
                     ");
      } else{
        $db->query("UPDATE `configuration` SET `configuration_value`='250'  WHERE configuration_key= 'SMALL_IMAGE_HEIGHT';");
      }
      if ( !defined('HEADING_IMAGE_WIDTH') ) {
        $db->query("INSERT INTO configuration (configuration_title,configuration_key,configuration_value,configuration_description,configuration_group_id,sort_order,date_added, use_function, set_function) VALUES
                      ('Heading Image Width', 'HEADING_IMAGE_WIDTH', '57', 'The pixel width of heading images', '4', '3', NOW(), null, null);
                     ");
      } else{
        $db->query("UPDATE `configuration` SET `configuration_value`='57'  WHERE configuration_key= 'HEADING_IMAGE_WIDTH';");
      }
      if ( !defined('HEADING_IMAGE_HEIGHT') ) {
        $db->query("INSERT INTO configuration (configuration_title,configuration_key,configuration_value,configuration_description,configuration_group_id,sort_order,date_added, use_function, set_function) VALUES
                      ('Heading Image Height', 'HEADING_IMAGE_HEIGHT', '57', 'The pixel height of heading images', '4', '4', NOW(), null, null);
                     ");
      } else{
        $db->query("UPDATE `configuration` SET `configuration_value`='40'  WHERE configuration_key= 'HEADING_IMAGE_HEIGHT';");
      }

      if (defined('KISSIT_DEFAULT_MISSING_IMAGE')) 	$db->query("DELETE FROM `configuration` WHERE configuration_key= 'KISSIT_DEFAULT_MISSING_IMAGE';");

    }

  }

}
