<?php
/*
* $Id: kiss_image_functions.php
* $Loc: /includes/hooks/admin/system/
*
* Name: KissitImage
* Version: 4.7.1
* Release Date: 11/29/2024
* Author: Rainer Schmied
* 	 phoenixcartaddonsaddons.com / raiwa@phoenixcartaddons.com
*
* License: Released under Commercial License
*
* Comments:  Author: [Rainer Schmied @raiwa]
*  Author URI: [www.phoenixcartaddons.com]
*  License: Commercial License Rainer Schmied
*  License URI: https://www.phoenixcartaddons.com/license.php
* 
*  Copyright (c) 2024 Rainer Schmied
*  
* Based on:
* S. Mohammed Alsharaf, http://www.zfsnippets.com/snippets/view/id/44.
* Copyright 2008-2009 FWR Media ( Robert Fisher )
* 
* Author Robert Fisher, FWR Media, http://www.fwrmedia.co.uk
*  Redistribution and use in source and binary forms, with or without
*  modification, are not permitted without specific prior written permission
*  from Rainer Schmied
* 
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
*  SOFTWARE.
*  
* 
*/

class hook_admin_system_kiss_image_functions {
  var $version = '4.5.4';

}

// Function to reset KISSit image thumbs cache entries and directories
	function tep_destroy_thumbs_dir( $dir = '' ) {
    if (!is_dir($dir) || is_link($dir)) return unlink($dir);
    foreach (scandir($dir) as $file) {
    	if ($file == '.' || $file == '..') continue;
      if (!tep_destroy_thumbs_dir($dir . '/' . $file)) {
      	chmod($dir . '/' . $file, 0777);
        if (!tep_destroy_thumbs_dir($dir . '/' . $file)) return false;
      };
    }
    return rmdir($dir);
  }

// Function to reset KISSit image thumbs cache entries
  function tep_cfg_reset_thumbs_cache( $action = 'false' ) {
  	if ('reset' === $action ) {
  		$dir = DIR_FS_CATALOG . 'images/' . KISSIT_THUMBS_MAIN_DIR;
  		if (file_exists($dir)) {
  			tep_destroy_thumbs_dir($dir);
  		}
  		$admin_dir = DIR_FS_ADMIN . 'images/' . KISSIT_THUMBS_MAIN_DIR;
  		if (file_exists($admin_dir)) {
  			tep_destroy_thumbs_dir($admin_dir);
  		}
  		$GLOBALS['db']->query(<<<'EOSQL'
UPDATE configuration
  SET configuration_value='false'
  WHERE configuration_key='KISSIT_RESET_IMAGE_THUMBS'
EOSQL
      );
  	}
    return $action;
  }
