<?php
/*
* $Id: product_card.php
* $Loc: /templates/override/includes/components/
*
* Name: KissitImage
* Version: 4.7.1
* Release Date: 11/29/2024
* Author: Rainer Schmied
* 	 phoenixcartaddonsaddons.com / raiwa@phoenixcartaddons.com
*
* License: Released under Commercial License
*
* Comments:  Author: [Rainer Schmied @raiwa]
*  Author URI: [www.phoenixcartaddons.com]
*  License: Commercial License Rainer Schmied
*  License URI: https://www.phoenixcartaddons.com/license.php
* 
*  Copyright (c) 2024 Rainer Schmied
*  
* Based on:
* S. Mohammed Alsharaf, http://www.zfsnippets.com/snippets/view/id/44.
* Copyright 2008-2009 FWR Media ( Robert Fisher )
* 
* Author Robert Fisher, FWR Media, http://www.fwrmedia.co.uk
*  Redistribution and use in source and binary forms, with or without
*  modification, are not permitted without specific prior written permission
*  from Rainer Schmied
* 
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
*  SOFTWARE.
*  
* 
*/

  if (!isset($card) || !is_array($card)) {
    $card = [];
  }
  if (!isset($buttons) || !is_array($buttons)) {
    $buttons = [];
  }

  $parameters = [
    'product' => &$product,
    'card' => &$card,
    'buttons' => &$buttons,
    'tpl_data' => $tpl_data ?? [],
  ];
  $GLOBALS['hooks']->cat('injectProductCard', $parameters);
?>
  <a href="<?= $product->get('link') ?>"><?= (new Image('images/' . $product->get('image'), ['width' => SMALL_IMAGE_WIDTH, 'height' => SMALL_IMAGE_HEIGHT], htmlspecialchars($product->get('name'))))->append_css('card-img-top') ?></a>
  <div class="card-body">
    <h5 class="card-title"><a href="<?= $product->get('link') ?>"><?= $product->get('name') ?></a></h5>
    <h6 class="card-subtitle mb-2 text-muted"><?= $product->hype_price() ?></h6>
    <?= implode('<br>', $card['extra'] ?? []) ?>
  </div>

<?php
  if (count($buttons) > 0) {
?>

  <div class="card-footer bg-white pt-0 border-0">
    <div class="d-flex justify-content-between"><?= implode(PHP_EOL, $buttons) ?></div>
  </div>

<?php
  }
?>
